#include <windows.h>
#include <stdio.h>
#include <conio.h>
#include <time.h>
#include "WUSBdrv.h"


void TestWriteSpped()
{
	printf("\nTest Write Speed: \n");


	WUSB_SetupPortB(SYNC_MODE_INTERNAL_CLK_48MHZ);		
	char buf[65535];
	//char buf[512];
	unsigned int dwWrite = 0;
	unsigned int ByteCounter = 0;
	

	int t1 = clock();
	for(int i = 0; i < 1000; i++)
	{
		WUSB_WritePortB(buf, sizeof(buf), &dwWrite);
		ByteCounter += dwWrite;		
	}
	int t2 = clock();


	double WriteTime = ((double)(t2 - t1))/1000.0; //[sec]
	double RateMbyt  = ((double)ByteCounter)/(1048576.0)/WriteTime;
	double RateMbit  = RateMbyt*8;


	printf("Time:		%d ms\n", t2-t1);
	printf("ByteCounter:	%d byte\n", ByteCounter);
	printf("Rate:		%f MBit_s\n", RateMbit);
	printf("		%f MByte_s\n", RateMbyt);
}


void TestReadSpped()
{
	printf("\nTest Read Speed: \n");


	WUSB_SetupPortB(ASYNC_MODE);

	char buf[65024];
	unsigned int dwRead;
	unsigned int ByteCounter = 0;
	

	int t1 = clock();
	for(int i = 0; i < 1000; i++)
	{
		WUSB_ReadPortB(buf, sizeof(buf), &dwRead);
		ByteCounter += dwRead;
	}
	int t2 = clock();

  for(int j=0; j<10; j++)
  {
    printf("%X ", (unsigned char)buf[j]);
  }
  printf("\r\n");


	double ReadTime  = ((double)(t2 - t1))/1000.0; //[sec]
	double RateMbyt  = ((double)ByteCounter)/(1048576.0)/ReadTime;
	double RateMbit  = RateMbyt*8;


	printf("Time:		%d ms\n", t2-t1);
	printf("ByteCounter:	%d byte\n", ByteCounter);
	printf("Rate:		%f MBit_s\n", RateMbit);
	printf("		%f MByte_s\n", RateMbyt);
}


int main()
{
	int status = WUSB_Open();

	if(status == WUSB_ERROR)
	{
		printf("ERROR! Can`t open WodmanUSB device...\n");
		getch();
		return false;
	}
	else
	{
		printf("WodmanUSB Open Ok!\n");		
	}


	//TestWriteSpped();
	TestReadSpped();


	getch();
	WUSB_Close();
	return true;
}

